[Date Prev][Date Next] [Thread Prev][Thread Next] [Date Index] [Thread Index]

Bug#601126: eglibc: [m68k] please apply patch for m68k TLS support



Source: eglibc
Version: 2.11.2-6
Severity: wishlist
Tags: patch

Hi,

please apply the attached debdiff, which after discussion on the
Debian m68k mailing list with great help from Finn Thain will
make eglibc build with TLS support on m68k given both kernel and
toolchain that support it. (These are not currently in the ar-
chive, but uploads will be made once cleanly built packages are
available – I’m sorta re-bootstrapping the port – and as newer
libcs than 2.5 have never been built on m68k, won’t hurt.)

Thanks!
diff -u eglibc-2.11.2/debian/changelog eglibc-2.11.2/debian/changelog
--- eglibc-2.11.2/debian/changelog
+++ eglibc-2.11.2/debian/changelog
@@ -1,3 +1,15 @@
+eglibc (2.11.2-6+m68k.2) unreleased; urgency=low
+
+  * debian/sysdeps/m68k.mk: switch m68k to TLS
+    - use nptl instead of linuxthreads
+    - remove libc_extra_config_options (all of them, we have __thread
+      and tls now; sanity checks were only disabled for linuxthreads)
+    - raise minimum kernel version to 2.6.16 and document why we can't
+      set it to 2.6.32 (Debian) yet which would be correct/desired
+  * debian/debhelper.in/libc.preinst: require 2.6.32 kernel on m68k
+
+ -- Thorsten Glaser <tg@mirbsd.de>  Fri, 22 Oct 2010 10:01:02 +0000
+
 eglibc (2.11.2-6) unstable; urgency=low
 
   [ Aurelien Jarno ]
diff -u eglibc-2.11.2/debian/debhelper.in/libc.preinst eglibc-2.11.2/debian/debhelper.in/libc.preinst
--- eglibc-2.11.2/debian/debhelper.in/libc.preinst
+++ eglibc-2.11.2/debian/debhelper.in/libc.preinst
@@ -292,33 +292,22 @@
         mips*) realarch="mips";;
       esac
 
-      # The GNU libc requires a >= 2.6.18 kernel (except on m68k)
+      # The GNU libc requires a >= 2.6.32-3 Debian kernel on m68k
+      # for TLS, or a >= 2.6.18 kernel on all other architectures
       if [ "$realarch" != m68k ]
       then
-          if linux_compare_versions "$kernel_ver" lt 2.6.18
-          then
-              echo WARNING: this version of the GNU libc requires kernel version
-              echo 2.6.18 or later.  Please upgrade your kernel before installing
-              echo glibc.
-              kernel26_help
-
-              exit 1
-          fi
+          vmin=2.6.18
+      else
+          vmin=2.6.32
       fi
-
-      # The GNU libc is now built with --with-kernel= >= 2.4.1 on m68k
-      if [ "$realarch" = m68k ]
+      if linux_compare_versions "$kernel_ver" lt ${vmin}
       then
-          if linux_compare_versions "$kernel_ver" lt 2.4.1
-          then
-              echo WARNING: This version of glibc requires that you be running
-              echo kernel version 2.4.1 or later.  Earlier kernels contained
-              echo bugs that may render the system unusable if a modern version
-              echo of glibc is installed.
-              kernel26_help
+          echo WARNING: this version of the GNU libc requires kernel version
+          echo ${vmin} or later.  Please upgrade your kernel before installing
+          echo glibc.
+          kernel26_help
 
-              exit 1
-          fi
+          exit 1
       fi
 
       # From glibc 2.6-3 SPARC V8 support is dropped.
diff -u eglibc-2.11.2/debian/sysdeps/m68k.mk eglibc-2.11.2/debian/sysdeps/m68k.mk
--- eglibc-2.11.2/debian/sysdeps/m68k.mk
+++ eglibc-2.11.2/debian/sysdeps/m68k.mk
@@ -1,3 +1,5 @@
-libc_MIN_KERNEL_SUPPORTED = 2.4.1
-libc_add-ons = ports linuxthreads $(add-ons)
-libc_extra_config_options = $(extra_config_options) --disable-sanity-checks --without-__thread --without-tls
+# actually, Debian 2.6.32-23 and up, or Mainline 2.6.34
+# but we need the compatibility functions compiled in through
+# this until patched appropriately
+libc_MIN_KERNEL_SUPPORTED = 2.6.16
+libc_add-ons = ports nptl $(add-ons)

Reply to: